#include<iostream>
#include"vector.h"
#include"point.h"
#include<assert.h>
#include"knots.h"

using namespace std;

vector::vector()
{
  data = NULL;
  size = 0;
}

vector::vector( int numElts):size(numElts)
{
  data = new point[size];
  assert(data!=0);
}

vector::vector(const vector & source)
{
  size = source.size;
  data=new point[size];
  assert(data!=0);

  for(int i=0; i<size; i++)
    data[i] = source.data[i];
}

vector & vector::operator =(const vector & source)
{
  if (this != &source)
    {
      delete [] data;
      size = source.size;
      data = new point[size];

      assert(data != 0);
      
      for(int i=0; i<size; i++)
	data[i] = source.data[i];
    }

  return *this;
}  

vector::~vector()
{
  delete [] data;
  data = 0;
  size = 0;
}

point & vector::operator [] (int index)
{
  return data[index];
}

const point & vector::operator [] (int index) const
{
  return data[index];
}

int vector::length() const
{
  return size;
}

int vector::setSize(int numberOfElements)
{
  point * newData = new point[numberOfElements];
  assert(newData != 0);

  delete [] data;
  size = numberOfElements;
  data = newData;

  return size;
}


vector operator *(const double & scalar, const vector & source)
{
  int i, j;
  int size = source.length();
  vector multiple(size);
  
  for(i=0; i<size; i++)
    for(j=0; j<3; j++)
      multiple[i][j] = scalar * source[i][j];

  return multiple;
}
